#include <stdio.h>
#include <allegro.h>
#include <math.h>
#include <string.h>
#include "space.h"

//objects are 54 by 40

#define ALIEN_SPEED 1
#define BULLET_SPEED 4
#define EXPLODE_SIZE 30
#define EXPLODE_SPEED 2
#define MAX_ALIENS 100
#define BOTTOM 459


int NO_AMMO_LIMIT=0;



volatile long int round_timer,timer;

void timer_funct()
{
	round_timer++;
	timer++;
}

END_OF_FUNCTION(timer_funct);


BITMAP * buff;
DATAFILE * data;

//find angle between x1,y1 and x2,y2 (in radians)
float find_angle(int x1,int y1,int x2,int y2)
{
float angle=0;

	if( (x1-x2) !=0){
				angle=atan( fabs((float)y1-(float)y2)/fabs((float)x1-(float)x2)); 
			
		
				//quadrent 1
				if(x2> x1 && y2<y1)angle=2*M_PI-angle;
			
				//quadrent 2
				if(x2<x1 && y2<y1)angle=M_PI+angle;

				//quadrent 3
				if(x2< x1 && y2 > y1)angle=M_PI-angle;

				//quadrent 4
				if(x2> x1 && y2 > y1)angle=angle;			

				
	}
	
	else{
		//cant do atan (div by 0)
		if(y2<y1)angle=M_PI+M_PI/2;
		else angle=M_PI/2;
	}

	return angle;

}

float dist(int x1,int y1,int x2,int y2)
{
	return sqrt( (float) ( ((x2-x1)*(x2-x1)) + ((y2-y1)*(y2-y1)) ) );
} 

float confine_gun(float angle, int what)
{

	if(what==0){
		if(angle>(M_PI*2)-.08 || angle<M_PI/2)angle=(M_PI*2)-.08 ;
		if(angle<M_PI+M_PI/2 && angle>=M_PI/2)angle=M_PI+M_PI/2;
 	}
	
	if(what==1){
		if(angle<M_PI+.08 && angle>M_PI/2)angle=M_PI+.08 ;
		if(angle>M_PI+M_PI/2 || angle<=M_PI/2)angle=M_PI+M_PI/2;
 	}



	

	return angle;
}

class FLAGS{
public:
	int rbutton,lbutton,space;
	int rammo,lammo;
	
}flags;


class BULLET{
public:

	float x,y;
	float dir;
	float speed,xinc,yinc;
	int status;
	int explode;
	int life;
	
	BULLET() {status=0;explode=0;}
	void update();
	void draw();

}bullet[100];
	
void BULLET::draw()
{
	if(status==1)putpixel(buff,(int)x,(int)y,6);
	if(status==2)circlefill(buff,(int)x,(int)y,explode<EXPLODE_SIZE ? explode : EXPLODE_SIZE*2-explode,250);
}


void BULLET::update()
{
	if(status==0)return;

	if(status==1){
		x+=xinc;
		y+=yinc;
		life--;
	}


	if(life==0){life=-1;status=2; explode=0;}
	
	if(status==2)explode+=EXPLODE_SPEED;
	if(explode>=EXPLODE_SIZE*2)status=0;

}

class OBJECT{  //city of gun
public:
	int over;
	int status;//1= alive 2=dead
	int type;//1= city   2=gun
	float angle;//used for guns ( angle between gun and crosshair)
	
	void draw(int);

}object[10];


void OBJECT::draw(int hflip)
{
BITMAP * temp;

int xup,yup,offset=0;

	if(status==0)return;

	if(!hflip)offset=10;
	else offset=54-10;


	//aim gun ( gun only)

	
	if(type==2){
		angle=find_angle(over+offset,480-60+32,mouse_x,mouse_y);
		angle=confine_gun(angle,hflip);

		xup=(int)(cos(angle)*50);
		yup=(int) (sin(angle)*50);
		line(buff,over+offset,480-60+32,over+offset+xup,480-60+32+yup,5);		
		//if(!hflip)textprintf(buff,font,0,0,4,"%f",angle);





	}

	if(type==1)temp=(BITMAP *)data[CITY].dat;
	if(type==2)temp=(BITMAP *)data[GUN].dat;

	if(!hflip)masked_blit(temp,buff,0,0,over,480-60,54,40);
	if(hflip)draw_sprite_h_flip(buff,temp,over,480-60);

}


class ALIEN{
public:
	float x,y;
	float dir;
	float xinc,yinc,speed;
	int targetx;
	int startx,starty;
	int status,type;
	ALIEN(){status=0;}

	void draw();
	void update();
}alien[MAX_ALIENS];


long times[MAX_ALIENS];

void ALIEN::draw()
{
	if(status==0)return;
	
	if(type==0){//alien
		line(buff,(int)startx,(int)starty,(int)x,(int)y,5);
		rectfill(buff,(int)x-1,(int)y-1,(int)x+1,(int)y+1,250);
	}

	if(type==1){//ammo
		
		rectfill(buff,(int)x-2,(int)y-2,(int)x+2,(int)y+2,120);
	}

	

}

void ALIEN::update()
{
int i,hit=0;
	if(status==0)return;
	x+=xinc;
	y+=yinc;

	//check bullet hit
	for(i=0;i<100;i++){
		if(bullet[i].status!=2)continue;

		if(bullet[i].explode<EXPLODE_SIZE){
			if(dist( (int)x,(int)y, (int)bullet[i].x, (int) bullet[i].y) <bullet[i].explode)hit=1;
		}

		if(bullet[i].explode>=EXPLODE_SIZE){
			if(dist( (int)x,(int)y, (int)bullet[i].x, (int) bullet[i].y) < (EXPLODE_SIZE*2-bullet[i].explode) )hit=1;
		}
	}
		

	if(y>=(float)BOTTOM){
		status=0;
		
		//check deaths of buildings (aliens only) 
		if(type==0)for(i=0;i<10;i++)if(x>=(int)object[i].over && x<(int)object[i].over+54)object[i].status=0;



	}

	if(hit==1){
		status=0;

		if(type==1 && flags.lammo!=-1){flags.rammo+=5; flags.lammo+=5; return;}

		for(i=0;i<100;i++){
				if(bullet[i].status!=0)continue;
	

				bullet[i].status=2;
				bullet[i].x=x;
				bullet[i].y=y;
				
				bullet[i].life=-1;
				
				bullet[i].xinc=(float)0;
				bullet[i].yinc=(float)0;
				bullet[i].explode=0;
				break;

		}
	}
		

}











void init(void)
{
int t;
t=2324;
	int x;


	//gettime(&t);
	allegro_init();
	
	install_timer();
	install_mouse();
	install_keyboard();
	set_gfx_mode(GFX_BEOS_WINDOWED,640,480,0,0);
	buff=create_bitmap(640,480);
	data=load_datafile("space.dat");

	srand(t);

	//set up types of objects

	for(x=0;x<10;x++){
		object[x].status=object[x].type=1;
		object[x].over=x*64+5;
	}

	object[0].type=object[9].type=2;

	set_pallete((RGB *)data[GAME_PAL].dat);


	set_mouse_range(13, 0, 640-13, 480-26);
	
	LOCK_VARIABLE(timer);
	LOCK_VARIABLE(round_timer);
	LOCK_FUNCTION(timer_funct);

	install_int(timer_funct,1);

   


}


void draw_all(int level)
{
	int x=0;

	clear(buff);

	//draw objects
	for(x=0;x<9;x++){
		object[x].draw(0);
	}
	
	object[9].draw(1);// this side is fliped around

	for(x=0;x<100;x++){
		bullet[x].draw();
	}
	for(x=0;x<MAX_ALIENS;x++){
		alien[x].draw();
	}




	//mouse curser
	line(buff,mouse_x-1,mouse_y,mouse_x-5,mouse_y,2);
	line(buff,mouse_x+1,mouse_y,mouse_x+5,mouse_y,2);
	line(buff,mouse_x,mouse_y-1,mouse_x,mouse_y-5,2);
	line(buff,mouse_x,mouse_y+1,mouse_x,mouse_y+5,2);

	

	line(buff,0,BOTTOM+1,639,BOTTOM+1,5);



	//draw ammo left
	textprintf(buff,font,12,BOTTOM+7,100,"%d",flags.lammo);
	textprintf(buff,font,580,BOTTOM+7,100,"%d",flags.rammo);




	

	/*
	for(x=0;x<flags.lammo;x++){
		draw_sprite(buff,(BITMAP *)data[MISSLE].dat,10+9*x,BOTTOM+3);
	}

	for(x=0;x<flags.rammo;x++){
		draw_sprite(buff,(BITMAP *)data[MISSLE].dat,640-17-9*x,BOTTOM+3);
	}
	*/

	textprintf_centre(buff,font,320,240,100,"%d",level);


	blit(buff,screen,0,0,0,0,640,480);
}

void create_alien(int type)
{
int i;
		for(i=0;i<MAX_ALIENS;i++){
				if(alien[i].status!=0)continue;
	

				alien[i].status=1;
				alien[i].startx=rand()%640;
				alien[i].starty=0;
				alien[i].x=(float)alien[i].startx;
				alien[i].y=(float)alien[i].starty;
				alien[i].targetx=rand()%640;
				alien[i].dir=find_angle(alien[i].startx,alien[i].starty,alien[i].targetx,BOTTOM);
				alien[i].type=type;
				alien[i].speed=(float)ALIEN_SPEED;

				if(type==1)alien[i].speed *=2.5;

				alien[i].xinc=cos(alien[i].dir)*alien[i].speed;
				alien[i].yinc=sin(alien[i].dir)*alien[i].speed;
				
				break;

			}

	









}		



int main(int argc, char *argv[])
{


	int level=0,aliens=0;
	int i,x,y,xup,yup,fire=0;
	float dir;

int counti;
char datapath[256];

	printf("Welcome to yet another random game by Infested Furby Software...\n\n\n\n");
	printf("Amount of ammo ( for each turret)  (-1 for inifnite) : ");
	scanf("%d",&flags.rammo);
	NO_AMMO_LIMIT=1;
	
	flags.lammo=flags.rammo;

	for (counti=strlen(argv[0]) ; argv[0][counti]!='/' ; counti--);
strncpy(datapath, argv[0], counti);
chdir(datapath);

	init();

	
	do{

		timer=0;

		draw_all(level);

		for(i=0;i<100;i++)bullet[i].update();
		for(i=0;i<MAX_ALIENS;i++)alien[i].update();




		
		//fire bullets


		if(mouse_b&1){}else flags.lbutton=0;
		if(mouse_b&2){}else flags.rbutton=0;
		if(!key[KEY_SPACE])flags.space=0;



			aliens=0;
		for(i=0;i<MAX_ALIENS;i++)if(alien[i].status){aliens=1;break;}

		if(aliens==0)for(i=0;i<level;i++)if(times[i]>=0)aliens=1;//dont go to next round till all aliens have been made

		if(aliens==0){	//set up round

			round_timer=0;

			//no aliens left, make more
			level++;
			//for(i=0;i<level;i++)create_alien();
			
			for(i=0;i<level+1;i++)times[i]=rand()%5000;
			times[0]=0;//make one come at start, get rid of down times
		}

		//create aliens based on times
		for(i=0;i<level;i++){
			if(times[i]<round_timer && times[i]>=0){
				create_alien(0);
				times[i]=-1;//dont make another for this time
			}
		}


		//create ammo maker for each round
		if(times[level]<round_timer && times[level]>=0){
			create_alien(1);
			times[i]=-1;//dont make another for this time
		}



		//make alien by press space(temporary)


		if(key[KEY_SPACE] && flags.space==0 ){
			
			flags.space=1;
			create_alien(0);
		}	



			




		if(mouse_b&1 && flags.lbutton==0 && object[0].status==1 && (NO_AMMO_LIMIT==0 ? flags.lammo>0 : 1)){
			flags.lbutton=1;

			if(flags.lammo>0)flags.lammo--;


			dir=object[0].angle;
			xup=(int)(cos(dir)*50);
			yup=(int) (sin(dir)*50);

			x=object[0].over+10+xup;
			y=480-60+32+yup;
			


			fire=1;




		}

		if(mouse_b&2 && flags.rbutton==0 && object[9].status==1 && (NO_AMMO_LIMIT==0 ? flags.rammo>0 : 1)){
			flags.rbutton=1;

			if(flags.rammo>0)flags.rammo--;

			
			dir=object[9].angle;
			xup=(int)(cos(dir)*50);
			yup=(int) (sin(dir)*50);

			x=object[9].over+54-10+xup;
			y=480-60+32+yup;
			


			fire=1;




		}




		if(fire==1){
			//clear(screen);
			fire=0;
			for(i=0;i<100;i++){
				if(bullet[i].status!=0)continue;
	

				bullet[i].status=1;
				bullet[i].x=(float)x;
				bullet[i].y=(float)y;
				bullet[i].dir=dir;
				bullet[i].life=(int)(dist(x,y,mouse_x,mouse_y)/BULLET_SPEED);
				bullet[i].speed=(float)BULLET_SPEED;
				bullet[i].xinc=cos(dir)*bullet[i].speed;
				bullet[i].yinc=sin(dir)*bullet[i].speed;
				bullet[i].explode=0;
				break;

			}
		}	


		
		do{}while(timer<33);

	}while(!key[KEY_ESC] );

	

}









